Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/src/Parameters.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/src/Parameters.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/src/Parameters.cpp	(revision 88)
@@ -424,20 +442,24 @@
 	 _nb_ooo_engine              ,
 	 _nb_packet                  ,
-	 _size_general_data          ,
+	  size_general_data          ,
 	 _max_nb_general_register    ,
-	 _size_special_data          ,
+	  size_special_data          ,
 	 _max_nb_special_register    ,
 	 _nb_bypass_write         [i]);
 
 
+    log_printf(TRACE,Execute_loop,FUNCTION,"Parameters : read_unit_to_execution_unit");
+
     _param_read_unit_to_execution_unit = new morpheo::behavioural::core::multi_execute_loop::execute_loop::network::read_unit_to_execution_unit::Parameters
       (_nb_read_unit                                  ,
+       _nb_inst_retire                                ,
        _nb_execute_unit                               ,
+       _nb_execute_unit_port                          ,
        _nb_context                                    ,
        _nb_front_end                                  ,
        _nb_ooo_engine                                 ,
        _nb_packet                                     ,
-       _size_general_data                             ,
-       _size_special_data                             ,
+        size_general_data                             ,
+        size_special_data                             ,
        _max_nb_general_register                       ,
        _max_nb_special_register                       ,
@@ -449,6 +471,9 @@
        _read_unit_to_execution_unit_table_thread      );
     
+    log_printf(TRACE,Execute_loop,FUNCTION,"Parameters : execution_unit_to_write_unit");
+
     _param_execution_unit_to_write_unit = new morpheo::behavioural::core::multi_execute_loop::execute_loop::network::execution_unit_to_write_unit::Parameters
       (_nb_execute_unit                           ,
+       _nb_execute_unit_port                      ,
        _nb_write_unit                             ,
        _nb_context                                ,
@@ -456,6 +481,6 @@
        _nb_ooo_engine                             ,
        _nb_packet                                 ,
-       _size_general_data                         ,
-       _size_special_data                         ,
+        size_general_data                         ,
+        size_special_data                         ,
        _max_nb_general_register                   ,
        _max_nb_special_register                   ,
@@ -464,8 +489,10 @@
        _execution_unit_to_write_unit_table_thread );
       
+    log_printf(TRACE,Execute_loop,FUNCTION,"Parameters : register_unit");
+
     _param_register_unit = new morpheo::behavioural::core::multi_execute_loop::execute_loop::register_unit::Parameters
 	(_nb_ooo_engine             ,
-	 _size_general_data         ,
-	 _size_special_data         ,
+	  size_general_data         ,
+	  size_special_data         ,
 	 _nb_gpr_read               ,
 	 _nb_gpr_write              ,
@@ -483,5 +510,4 @@
 	 _nb_inst_retire_rob        );
 
-    
     _max_size_dcache_context_id = 0;
     _max_size_dcache_packet_id  = 0;
@@ -494,4 +520,28 @@
 
     _have_port_dcache_context_id = (_max_size_dcache_context_id>1);
+
+
+    if (is_toplevel)
+      {
+        _size_context_id         = log2(nb_context);
+        _size_front_end_id       = log2(nb_front_end);
+        _size_ooo_engine_id      = size_ooo_engine_id;
+        _size_rob_ptr            = log2(nb_packet);
+        _size_general_data       = size_general_data;
+        _size_special_data       = size_special_data;
+        _size_general_register   = size_general_register;
+        _size_special_register   = size_special_register;
+
+        _size_store_queue_ptr    = log2(_max_size_store_queue);
+        _size_load_queue_ptr     = log2(_max_size_load_queue );
+        
+        _have_port_context_id    = _size_context_id     > 0;
+        _have_port_front_end_id  = _size_front_end_id   > 0;
+        _have_port_ooo_engine_id = _size_ooo_engine_id  > 0;
+        _have_port_rob_ptr       = _size_rob_ptr        > 0;
+        _have_port_load_queue_ptr= _size_load_queue_ptr > 0;
+
+        copy();
+      }
 
     log_printf(FUNC,Execute_loop,FUNCTION,"End");
@@ -511,11 +561,26 @@
 #undef  FUNCTION
 #define FUNCTION "Execute_loop::~Parameters"
-  Parameters::~Parameters () 
+  Parameters::~Parameters (void) 
   {
     log_printf(FUNC,Execute_loop,FUNCTION,"Begin");
 
+    delete    _param_glue;
+    for (uint32_t i=0; i<_nb_read_unit; i++)
+      delete _param_read_unit [i];
     delete [] _param_read_unit;
+
+    for (uint32_t i=0; i<_nb_execute_unit; i++)
+      {
+        uint32_t x = _translate_num_execute_unit [i];
+
+        if (_is_load_store_unit [i] == false)
+          delete _param_functionnal_unit [x];
+        else
+          delete _param_load_store_unit [x];
+      }
     delete [] _param_functionnal_unit;
     delete [] _param_load_store_unit;
+    for (uint32_t i=0; i<_nb_write_unit; i++)
+      delete _param_write_unit [i];
     delete [] _param_write_unit;
     delete    _param_read_unit_to_execution_unit;
@@ -535,4 +600,33 @@
     delete [] _is_load_store_unit;
     delete [] _translate_num_execute_unit;
+    delete [] _nb_execute_unit_port;
+    log_printf(FUNC,Execute_loop,FUNCTION,"End");
+  };
+
+
+#undef  FUNCTION
+#define FUNCTION "Execute_loop::copy"
+  void Parameters::copy (void) 
+  {
+    log_printf(FUNC,Execute_loop,FUNCTION,"Begin");
+
+    COPY(_param_glue);
+    for (uint32_t i=0; i<_nb_read_unit; i++)
+      COPY(_param_read_unit [i]);
+
+    for (uint32_t i=0; i<_nb_execute_unit; i++)
+      {
+        uint32_t x = _translate_num_execute_unit [i];
+
+        if (_is_load_store_unit [i] == false)
+          COPY(_param_functionnal_unit [x]);
+        else
+          COPY(_param_load_store_unit [x]);
+      }
+    for (uint32_t i=0; i<_nb_write_unit; i++)
+      COPY(_param_write_unit [i]);
+    COPY(_param_read_unit_to_execution_unit);
+    COPY(_param_execution_unit_to_write_unit);
+    COPY(_param_register_unit);
 
     log_printf(FUNC,Execute_loop,FUNCTION,"End");
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/src/Parameters_msg_error.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/src/Parameters_msg_error.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/src/Parameters_msg_error.cpp	(revision 88)
@@ -25,4 +25,8 @@
     Parameters_test test ("Execute_loop");
 
+    for (uint32_t i=0; i<_nb_functionnal_unit; i++)
+      if (_nb_inst_functionnal_unit [i] != 1)
+	test.error(toString(_("Functionnal_unit [%d] must treat once instruction.\n"),i));
+
     log_printf(FUNC,Execute_loop,FUNCTION,"End");
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/src/Parameters_print.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/src/Parameters_print.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/src/Parameters_print.cpp	(revision 88)
@@ -68,4 +68,6 @@
 	xml. singleton_begin("speculative_load             "); xml.attribut("value",toString(_speculative_load             [i])); xml.singleton_end();
 	xml. singleton_begin("nb_bypass_memory             "); xml.attribut("value",toString(_nb_bypass_memory             [i])); xml.singleton_end();
+	xml. singleton_begin("nb_cache_port                "); xml.attribut("value",toString(_nb_cache_port                [i])); xml.singleton_end();
+	xml. singleton_begin("nb_inst_memory               "); xml.attribut("value",toString(_nb_inst_memory               [i])); xml.singleton_end();
 	xml.balise_close();
       }
@@ -109,4 +111,5 @@
     str += _param_execution_unit_to_write_unit->print(depth+1);
     str += _param_register_unit->print(depth+1);
+    str += _param_glue->print(depth+1);
 
     xml.comment("\n"+str);
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/SelfTest/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/SelfTest/Makefile	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/SelfTest/Makefile	(revision 88)
@@ -24,4 +24,6 @@
 library_clean			: Context_State_library_clean
 
+local_clean			:
+
 include                         $(DIR_COMPONENT)/Makefile.deps
 include                         $(DIR_MORPHEO)/Behavioural/Makefile.flags
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/SelfTest/config_min.cfg
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/SelfTest/config_min.cfg	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/SelfTest/config_min.cfg	(revision 88)
@@ -2,10 +2,8 @@
 1	1	+1	# nb_context
 1	1	+1	# nb_decod_unit
-1	1	+1	# nb_ooo_engine
 1	1	+1	# nb_inst_branch_complete
 0	0	+1	# size_depth                    [0] [nb_context]
 30	30	+1	# size_address			
 1	1	+1	# size_inst_decod               [0] [nb_decod_unit]
-1	1	+1	# size_inst_commit              [0] [nb_ooo_engine]
+1	1	+1	# size_inst_commit
 0	0	+1	# link_context_to_decod_unit    [0] [nb_context]
-0	0	+1	# link_decod_unit_to_ooo_engine [0] [nb_decod_unit]
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/SelfTest/config_mono_context.cfg
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/SelfTest/config_mono_context.cfg	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/SelfTest/config_mono_context.cfg	(revision 88)
@@ -2,10 +2,8 @@
 1	1	+1	# nb_context
 1	1	*4	# nb_decod_unit
-1	1	*4	# nb_ooo_engine
 1	4	*4	# nb_inst_branch_complete
 0	2	+1	# size_depth                    [0] [nb_context]
 30	30	+1	# size_address			
 1	4	*4	# size_inst_decod               [0] [nb_decod_unit]
-1	4	*4	# size_inst_commit              [0] [nb_ooo_engine]
+1	4	*4	# size_inst_commit
 0	0	+1	# link_context_to_decod_unit    [0] [nb_context]
-0	0	+1	# link_decod_unit_to_ooo_engine [0] [nb_decod_unit]
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/SelfTest/config_multi_context.cfg
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/SelfTest/config_multi_context.cfg	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/SelfTest/config_multi_context.cfg	(revision 88)
@@ -2,5 +2,4 @@
 8	8	+1	# nb_context
 4	4	*4	# nb_decod_unit
-2	2	*4	# nb_ooo_engine
 2	2	*4	# nb_inst_branch_complete
 4	4	+1	# size_depth                    [0] [nb_context]
@@ -17,6 +16,5 @@
 2	2	*4	# size_inst_decod               [2] [nb_decod_unit]
 4	4	*4	# size_inst_decod               [3] [nb_decod_unit]
-8	8	*4	# size_inst_commit              [0] [nb_ooo_engine]
-2	2	*4	# size_inst_commit              [1] [nb_ooo_engine]
+8	8	*4	# size_inst_commit
 0	0	+1	# link_context_to_decod_unit    [0] [nb_context]
 1	1	+1	# link_context_to_decod_unit    [1] [nb_context]
@@ -27,6 +25,2 @@
 2	2	+1	# link_context_to_decod_unit    [6] [nb_context]
 3	3	+1	# link_context_to_decod_unit    [7] [nb_context]
-0	0	+1	# link_decod_unit_to_ooo_engine [0] [nb_decod_unit]
-1	1	+1	# link_decod_unit_to_ooo_engine [1] [nb_decod_unit]
-0	0	+1	# link_decod_unit_to_ooo_engine [2] [nb_decod_unit]
-1	1	+1	# link_decod_unit_to_ooo_engine [3] [nb_decod_unit]
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/SelfTest/src/main.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/SelfTest/src/main.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/SelfTest/src/main.cpp	(revision 88)
@@ -16,12 +16,10 @@
   err (_(" * nb_context                                    (uint32_t)\n"));
   err (_(" * nb_decod_unit                                 (uint32_t)\n"));
-  err (_(" * nb_ooo_engine                                 (uint32_t)\n"));
   err (_(" * nb_inst_branch_complete                       (uint32_t)\n"));
   err (_(" * size_depth                    [nb_context]	   (uint32_t)\n"));
   err (_(" * size_address                                  (uint32_t)\n"));
   err (_(" * size_inst_decod               [nb_decod_unit] (uint32_t)\n"));
-  err (_(" * size_inst_commit              [nb_ooo_engine] (uint32_t)\n"));
+  err (_(" * size_inst_commit                              (uint32_t)\n"));
   err (_(" * link_context_to_decod_unit    [nb_context]	   (uint32_t)\n"));
-  err (_(" * link_decod_unit_to_ooo_engine [nb_decod_unit] (uint32_t)\n"));
 
   exit (1);
@@ -45,8 +43,7 @@
   uint32_t   _nb_context              = fromString<uint32_t>(argv[x++]);
   uint32_t   _nb_decod_unit           = fromString<uint32_t>(argv[x++]);
-  uint32_t   _nb_ooo_engine           = fromString<uint32_t>(argv[x++]);
   uint32_t   _nb_inst_branch_complete = fromString<uint32_t>(argv[x++]);
 
-  if (argc != static_cast<int>(2+NB_PARAMS+2*_nb_context+2*_nb_decod_unit+1*_nb_ooo_engine))
+  if (argc != static_cast<int>(2+NB_PARAMS+2*_nb_context+1*_nb_decod_unit))
     usage (argc, argv);
 
@@ -60,13 +57,8 @@
   for (uint32_t i=0; i<_nb_decod_unit; i++)
     _size_inst_decod [i] = fromString<uint32_t>(argv[x++]);
-  uint32_t * _size_inst_commit              = new uint32_t [_nb_ooo_engine];
-  for (uint32_t i=0; i<_nb_ooo_engine; i++)
-    _size_inst_commit [i] = fromString<uint32_t>(argv[x++]);
+  uint32_t   _size_inst_commit              = fromString<uint32_t>(argv[x++]);
   uint32_t * _link_context_to_decod_unit    = new uint32_t [_nb_context];
   for (uint32_t i=0; i<_nb_context; i++)
     _link_context_to_decod_unit [i] = fromString<uint32_t>(argv[x++]);
-  uint32_t * _link_decod_unit_to_ooo_engine = new uint32_t [_nb_decod_unit];
-  for (uint32_t i=0; i<_nb_decod_unit; i++)
-    _link_decod_unit_to_ooo_engine [i] = fromString<uint32_t>(argv[x++]);
 
   int _return = EXIT_SUCCESS;
@@ -76,5 +68,4 @@
 	(_nb_context                   ,
 	 _nb_decod_unit                ,
-	 _nb_ooo_engine                ,
 	 _nb_inst_branch_complete      ,
 	 _size_depth                   ,
@@ -83,5 +74,5 @@
 	 _size_inst_commit             ,
 	 _link_context_to_decod_unit   ,
-	 _link_decod_unit_to_ooo_engine
+         true
 	 );
       
@@ -98,7 +89,5 @@
   delete [] _size_depth;                   
   delete [] _size_inst_decod;              
-  delete [] _size_inst_commit;             
   delete [] _link_context_to_decod_unit;   
-  delete [] _link_decod_unit_to_ooo_engine;
 
   try 
